/*
    tstore - an archive format for archiving tar archives
    Copyright (C) 2004-2005  Kasper Dupont

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    with permission from the author any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    $Id: tlist.c,v 1.3 2005/04/11 08:33:14 kasperd Exp $
*/

#include "tstore.h"

int main(int argc, char ** argv)
{
  uint64_t store_size;
  int store_fd;
  uint8_t buf[512];
  uint64_t idx,nidx;

  if (argc != 2) {
    fprintf(stderr,"Uage: %s <store>\n",argv[0]);
    return 1;
  }

  store_fd=open(argv[1],O_RDONLY);
  if (store_fd==-1) {
    perror(argv[1]);
    return 1;
  }

  store_size=test_store_size(store_fd,1);
  store_error(store_size,argv[1]);

  assert(pread(store_fd,buf,512,0)==512);

  for (idx=GET_BNUM(buf+NEXTPTR_OFFSET); idx; idx=nidx) {
    get_block(idx,buf,argv[1],store_fd);
    if (buf[FILENAME_OFFSET]==0) {
      printf("<Empty slot>\n");
    } else {
      printf("%lld\t%s\n",GET_SIZE(buf+FILESIZE_OFFSET),buf+FILENAME_OFFSET);
    }
    nidx=GET_BNUM(buf+NEXTPTR_OFFSET);
    if ((nidx>=store_size-1)||(nidx==idx)) {
      fprintf(stderr,"Invalid link %lld=>%lld\n",idx,nidx);
      return 1;
    }
  }
  return 0;
}
